/*!
 * $Id: Reach.cpp,v 1.3 2005/05/18 15:39:05 kidd Exp $
 *
 * @author Nick Kidd
 * @version $Revision: 1.3 $
 */

#include "Reach.h"

Reach::Reach( bool b ) :
    isreached(b),count(0) 
{
}

Reach* Reach::one() const
{
    return new Reach(true);
}

Reach* Reach::zero() const
{
    return new Reach(false);
}

// zero is the annihilator for extend
Reach* Reach::extend( const Reach* rhs ) const
{
    if( isreached && rhs->isreached )
        return one();
    else // this and rhs are one()
        return zero();
}

// zero is neutral for combine
Reach* Reach::combine( const Reach* rhs ) const
{
    if( isreached || rhs->isreached )
        return one();
    else
        return zero();
}

bool Reach::equal( const Reach* rhs ) const
{
    return ( isreached == rhs->isreached );
}

Reach* Reach::quasiOne() const
{
    return one();
}

std::ostream & Reach::print( std::ostream & o ) const
{
    return (isreached) ? o << "ONE" : o << "ZERO";
}

/*
 * $Log: Reach.cpp,v $
 * Revision 1.3  2005/05/18 15:39:05  kidd
 * *** empty log message ***
 *
 * Revision 1.2  2005/05/12 21:45:51  kidd
 * Made changes to reflect the contents of the user manual.
 *
 * Revision 1.1  2005/04/14 15:30:34  kidd
 *
 * Added "Reach" to Examples directory. This is the semiring in the user manual.
 * Using Reach is essentially using unweighted PDSs.
 *
 */
/* Yo, Emacs!
   ;;; Local Variables: ***
   ;;; tab-width: 4 ***
   ;;; End: ***
 */

