#ifndef REACH_GUARD
#define REACH_GUARD 1

/*!
 * $Id: Reach.h,v 1.2 2005/05/12 21:45:51 kidd Exp $
 *
 * @author Nick Kidd
 * @version $Revision: 1.2 $
 */

#include "ref_ptr.h"

class Reach
{

    bool isreached;
    public:

        ref_ptr<Reach>::count_t count;

        Reach( bool b );

        Reach* one() const;

        Reach* zero() const;

        // zero is the annihilator for extend
        Reach* extend( const Reach* rhs ) const;
        
        // zero is neutral for combine
        Reach* combine( const Reach* rhs ) const;
        
        bool equal( const Reach* rhs ) const;

        Reach* quasiOne() const;

        std::ostream & print( std::ostream & o ) const;
};

#endif	// REACH_GUARD

/*
 * $Log: Reach.h,v $
 * Revision 1.2  2005/05/12 21:45:51  kidd
 * Made changes to reflect the contents of the user manual.
 *
 * Revision 1.1  2005/04/14 15:30:34  kidd
 *
 * Added "Reach" to Examples directory. This is the semiring in the user manual.
 * Using Reach is essentially using unweighted PDSs.
 *
 */
/* Yo, Emacs!
;;; Local Variables: ***
;;; tab-width: 4 ***
;;; End: ***
*/

